CSIT python API introduction
[csit.git] / resources / libraries / bash / function / artifacts.sh
1 #!/usr/bin/env bash
2
3 # Copyright (c) 2018 Cisco and/or its affiliates.
4 # Licensed under the Apache License, Version 2.0 (the "License");
5 # you may not use this file except in compliance with the License.
6 # You may obtain a copy of the License at:
7 #
8 #     http://www.apache.org/licenses/LICENSE-2.0
9 #
10 # Unless required by applicable law or agreed to in writing, software
11 # distributed under the License is distributed on an "AS IS" BASIS,
12 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 # See the License for the specific language governing permissions and
14 # limitations under the License.
15
16 set -exuo pipefail
17
18 function download_artifacts () {
19     # Get and/or install VPP artifacts from packagecloud.io.
20     #
21     # Variables read:
22     # - CSIT_DIR - Path to existing root of local CSIT git repository.
23     # Variables set:
24     # - REPO_URL - FD.io Packagecloud repository.
25
26     set -exuo pipefail
27
28     os_id=$(grep '^ID=' /etc/os-release | cut -f2- -d= | sed -e 's/\"//g') || {
29         die "Get OS release failed."
30     }
31
32     repo_url_path="${CSIT_DIR}/VPP_REPO_URL"
33     if [ -e "${repo_url_path}" ]; then
34         REPO_URL="$(<${repo_url_path})" || {
35             die "Read repo URL from ${repo_url_path} failed."
36         }
37     else
38         REPO_URL="https://packagecloud.io/install/repositories/fdio/master"
39     fi
40
41     if [ "${os_id}" == "ubuntu" ]; then
42         download_ubuntu_artifacts || die
43     elif [ "${os_id}" == "centos" ]; then
44         download_centos_artifacts || die
45     elif [ "${os_id}" == "opensuse" ]; then
46         download_opensuse_artifacts || die
47     else
48         die "${os_id} is not yet supported."
49     fi
50 }
51
52 function download_ubuntu_artifacts () {
53     # Get and/or install Ubuntu VPP artifacts from packagecloud.io.
54     #
55     # Variables read:
56     # - REPO_URL - FD.io Packagecloud repository.
57     # - VPP_VERSION - VPP version.
58     # - INSTALL - If install packages or download only. Default: download
59
60     set -exuo pipefail
61
62     curl -s "${REPO_URL}"/script.deb.sh | sudo bash || {
63         die "Packagecloud FD.io repo fetch failed."
64     }
65     # If version is set we will add suffix.
66     artifacts=()
67     vpp=(vpp vpp-dbg vpp-dev vpp-lib vpp-plugins vpp-api-python)
68     if [ -z "${VPP_VERSION-}" ]; then
69         artifacts+=(${vpp[@]})
70     else
71         artifacts+=(${vpp[@]/%/=${VPP_VERSION-}})
72     fi
73
74     if [ "${INSTALL:-false}" = true ]; then
75         sudo apt-get -y install "${artifacts[@]}" || {
76             die "Install VPP artifacts failed."
77         }
78     else
79         apt-get -y download "${artifacts[@]}" || {
80             die "Download VPP artifacts failed."
81         }
82     fi
83 }
84
85 function download_centos_artifacts () {
86     # Get and/or install CentOS VPP artifacts from packagecloud.io.
87     #
88     # Variables read:
89     # - REPO_URL - FD.io Packagecloud repository.
90     # - VPP_VERSION - VPP version.
91     # - INSTALL - If install packages or download only. Default: download
92
93     set -exuo pipefail
94
95     curl -s "${REPO_URL}"/script.rpm.sh | sudo bash || {
96         die "Packagecloud FD.io repo fetch failed."
97     }
98     # If version is set we will add suffix.
99     artifacts=()
100     vpp=(vpp vpp-selinux-policy vpp-devel vpp-lib vpp-plugins vpp-api-python)
101     if [ -z "${VPP_VERSION-}" ]; then
102         artifacts+=(${vpp[@]})
103     else
104         artifacts+=(${vpp[@]/%/-${VPP_VERSION-}})
105     fi
106
107     if [ "${INSTALL:-false}" = true ]; then
108         sudo yum -y install "${artifacts[@]}" || {
109             die "Install VPP artifact failed."
110         }
111     else
112         sudo yum -y install --downloadonly --downloaddir=. "${artifacts[@]}" || {
113             die "Download VPP artifacts failed."
114         }
115     fi
116 }
117
118 function download_opensuse_artifacts () {
119     # Get and/or install OpenSuSE VPP artifacts from packagecloud.io.
120     #
121     # Variables read:
122     # - REPO_URL - FD.io Packagecloud repository.
123     # - VPP_VERSION - VPP version.
124     # - INSTALL - If install packages or download only. Default: download
125
126     set -exuo pipefail
127
128     curl -s "${REPO_URL}"/script.rpm.sh | sudo bash || {
129         die "Packagecloud FD.io repo fetch failed."
130     }
131     # If version is set we will add suffix.
132     artifacts=()
133     vpp=(vpp vpp-devel vpp-lib vpp-plugins libvpp0)
134     if [ -z "${VPP_VERSION-}" ]; then
135         artifacts+=(${vpp[@]})
136     else
137         artifacts+=(${vpp[@]/%/-${VPP_VERSION-}})
138     fi
139
140     if [ "${INSTALL:-false}" = true ]; then
141         sudo yum -y install "${artifacts[@]}" || {
142             die "Install VPP artifact failed."
143         }
144     else
145         sudo yum -y install --downloadonly --downloaddir=. "${artifacts[@]}" || {
146             die "Download VPP artifacts failed."
147         }
148     fi
149 }
150